# CVS $Id: rowcolumn.tcl,v 1.4 1995/04/28 12:52:17 zibi Exp $

#
# a minimal test of the rowcolumn widget
#

proc quitCB {form cbs} {
    WsClose
}

proc toggleChangedCB {cbs} {
	global label

	set wl [split [lindex $cbs 0] .]
	set wi [expr "[llength $wl] - 1"]
	WsSetValues $label \
		-label "[lindex $wl $wi] Value: [lindex $cbs 1]"
}

set fn [WsOpen testtoggles]

set fn [WsStartForm $fn.toggles -title "Toggles" \
       -xmArgs "XmNmarginWidth 10
                XmNmarginHeight 10
	        XmNbackground green"]

set rc1 [WsRowColumn $fn.rc1 -packing NONE ]

set tog ""
foreach i {0 1 2} {
        set j [expr $i * 30]
   	set tog [WsToggleButton $rc1.tog$i -label "Toggle $i" \
		-callback toggleChangedCB \
		-xmArgs "XmNx $i XmNy $j"]
}

set rc2 [WsRowColumn $fn.rc2 -below $rc1 -packing COLUMN \
	 -xmArgs "XmNbackground pink" ]

foreach i {4 5 6} {
   	set tog [WsToggleButton $rc2.tog$i -label "Toggle $i" -value 1 \
		-callback toggleChangedCB]
}

set rc3 [WsRowColumn $fn.rc3 -below $rc2 -packing TIGHT ]

foreach i {7 8 9} {
   	set tog [WsToggleButton $rc3.tog$i -label "Toggle $i" -value 0 \
		-callback toggleChangedCB]
}

set label [WsLabel $fn.label -label "No Callback Yet" -below $rc3]

WsPushButton $fn.quit -callback "quitCB $fn" \
    -below $label \
    -leftSide FORM\
    -rightSide FORM\
    -topOffset 10\
    -leftOffset 5 \
    -rightOffset 5\
    -CHARM_topOffset 1\
    -CHARM_leftOffset 2\
    -CHARM_rightOffset 2

WsShow $fn
WsMainLoop

